"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createJispParser = void 0;

function _typeof2(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof2 = function _typeof2(obj) { return typeof obj; }; } else { _typeof2 = function _typeof2(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof2(obj); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _iterableToArrayLimit(arr, i) { if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) { return; } var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

function _toArray(arr) { return _arrayWithHoles(arr) || _iterableToArray(arr) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var _require = require('lodash/fp'),
    get = _require.get;

var _require2 = require('lodash'),
    set = _require2.set;

function expand(ast, env) {
  if (!Array.isArray(ast)) return ast;

  var _ast = _toArray(ast),
      cmd = _ast[0],
      args = _ast.slice(1);

  var func = env[cmd];
  if (func === undefined) return ast;
  var M = func.M;
  if (M === undefined) return ast;
  return expand(func.apply(void 0, _toConsumableArray(args))); // while (Array.isArray(ast) && ast[0] in env && env[ast[0]].M) {
  //   ast = env[cmd](...args);
  // }
  // return ast;
}

var evalAst = function evalAst(ast, env, exprs) {
  if (exprs) {
    // Return new env with symbols in ast bound to
    // corresponding values in exprs
    env = Object.create(env);
    ast.forEach(function (a, i) {
      if (a === '&') env[ast[i + 1]] = exprs.slice(i);
      env[a] = exprs[i];
    });
    return env;
  } // Evaluate the form/ast


  if (Array.isArray(ast)) {
    return ast.map(function (a) {
      return evaluate(a, env);
    });
  }

  if (typeof ast === 'string') {
    var val = get(env, ast);
    return val !== undefined ? val : env["throw"]("".concat(ast, " not found"));
  }

  return ast; // return Array.isArray(ast) // list?
  //   ? ast.map((...a) => evaluate(a[0], ctx)) // list
  //   : typeof ast !== "string" // symbol?
  //   ? ast // ast unchanged
  //   : ast in ctx // symbol in ctx?
  //   ? ctx[ast] // lookup symbol
  //   : E.throw(ast + " not found"); // undefined symbol
}; // 2 args: eval_ast, 3 args: env_bind


function evaluate(ast, ctx) {
  while (true) {
    // console.log("evaluate:", ast)
    ast = expand(ast, ctx);
    if (!Array.isArray(ast)) return evalAst(ast, ctx);

    if (ast[0] === 'def') {
      // update current environment (ctx)
      var val = evaluate(ast[2], ctx);
      set(ctx, ast[1], val); // ctx[ast[1]] = evaluate(ast[2], ctx);

      return val;
    }

    if (ast[0] === '~') {
      // mark as macro
      var f = evaluate(ast[1], ctx); // eval regular function

      f.M = 1; // mark as macro

      return f;
    }

    if (ast[0] === '`') {
      // quote (unevaluated)
      return ast[1];
    }

    if (ast[0] === '.-') {
      // get or set attribute
      var el = evalAst(ast.slice(1), ctx);
      var x = el[0][el[1]];

      if (2 in el) {
        var _el = _slicedToArray(el, 3),
            y = _el[2];

        el[0][el[1]] = y;
        return y;
      }

      return x; // return 2 in el ? (el[0][el[1]] = el[2]) : x;
    }

    if (ast[0] === '.') {
      // call object method
      var _el2 = evalAst(ast.slice(1), ctx);

      var _x = _el2[0][_el2[1]];
      return _x.apply(_el2[0], _el2.slice(2));
    }

    if (ast[0] === 'try') {
      // try/catch
      try {
        return evaluate(ast[1], ctx);
      } catch (e) {
        return evaluate(ast[2][2], evalAst([ast[2][1]], ctx, [e]));
      }
    } else if (ast[0] === 'fn') {
      // define new function (lambda)
      var _f = function _f() {
        for (var _len = arguments.length, a = new Array(_len), _key = 0; _key < _len; _key++) {
          a[_key] = arguments[_key];
        }

        return evaluate(ast[2], evalAst(ast[1], ctx, a));
      };

      _f.A = [ast[2], ctx, ast[1]];
      return _f;
    } // TCO cases


    var _ast2 = ast,
        _ast3 = _slicedToArray(_ast2, 4),
        cmd = _ast3[0],
        arg1 = _ast3[1],
        arg2 = _ast3[2],
        arg3 = _ast3[3];

    if (cmd === 'let') {
      // new environment with bindings (ctx)
      ctx = Object.create(ctx);

      for (var i in arg1) {
        if (i % 2) {
          ctx[arg1[i - 1]] = evaluate(arg1[i], ctx);
        }
      }

      ast = arg2;
    } else if (cmd === 'do') {
      // multiple forms (for side-effects)
      var _el3 = evalAst(ast.slice(1, ast.length - 1), ctx);

      ast = ast[ast.length - 1];
    } else if (cmd === 'if') {
      // branching conditional
      ast = evaluate(arg1, ctx) ? arg2 : arg3;
    } else {
      // invoke list form
      var _el4 = evalAst(ast, ctx);

      var _el5 = _slicedToArray(_el4, 1),
          _f2 = _el5[0];

      var A = _f2.A;

      if (A) {
        var _A = _slicedToArray(A, 1),
            args = _A[0];

        ast = args;
        ctx = evalAst(_f2.A[2], _f2.A[1], _el4.slice(1));
      } else {
        return _f2.apply(void 0, _toConsumableArray(_el4.slice(1)));
      }
    }
  }
}

var createJispParser = function createJispParser(env) {
  var obj = Object.assign(Object.create(_objectSpread({}, env, {
    constructor: createJispParser
  })), {
    js: eval,
    // eslint-disable-line
    // These could all also be interop
    '=': function _(a, b) {
      return a === b;
    },
    '<': function _(a, b) {
      return a < b;
    },
    '+': function _(a, b) {
      return a + b;
    },
    '-': function _(a, b) {
      return a - b;
    },
    '*': function _(a, b) {
      return a * b;
    },
    '/': function _(a, b) {
      return a / b;
    },
    // isa: (...a) => a[0] instanceof a[1],
    "typeof": function _typeof(a) {
      return _typeof2(a);
    },
    "new": function _new() {
      var _a$;

      for (var _len2 = arguments.length, a = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
        a[_key2] = arguments[_key2];
      }

      return new ((_a$ = a[0]).bind.apply(_a$, a))();
    },
    // del: (...a) => delete a[0][a[1]],
    // "list":  (...a) => a,
    // "map":   (...a) => a[1].map(x => a[0](x)),
    "throw": function _throw(a) {
      throw a;
    },
    read: function read(a) {
      return JSON.parse(a);
    }
  }); // "slurp": (...a) => require("fs").readFileSync(a[0],"utf8"),
  // "load":  (...a) => evaluate(JSON.parse(require("fs").readFileSync(a[0],"utf8")),E),

  obj.rep = function (a) {
    return JSON.stringify(evaluate(JSON.parse(a), obj));
  };

  obj.eval = function (a) {
    console.log('EVAL ctx:', obj);
    return evaluate(a, obj);
  };

  return obj;
};

exports.createJispParser = createJispParser;
console.log(evalAst([]));