"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Rule = void 0;

var _joi = _interopRequireDefault(require("@hapi/joi"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var miniMALcmd = _joi["default"].array().min(1).items(_joi["default"].string().required(), _joi["default"].any());

var miniMALBlock = _joi["default"].array().items(_joi["default"].object().unknown(), miniMALcmd);

var Rule = _joi["default"].object().unknown().keys({
  id: _joi["default"].string().description('Identifier for this particular rule.'),
  active: _joi["default"]["boolean"]()["default"](false) // .required()
  .description('If the rule is active or not. An inactive rule is not run at all.'),
  // actuator: joi
  //   .string()
  //   .default('backend')
  //   .description('ID of where the rule should be loaded and run.'),
  ttl: _joi["default"].date().description('At this time (ISO timestamp) the rule will be set to inactive.'),
  cooldown: _joi["default"].number().min(0).description("A rule can't be triggered again unless this number of seconds has passed."),
  onLoad: miniMALBlock.description('MiniMAL command block to run when rule is loaded.'),
  process: miniMALBlock.description('MiniMAL command block to run when rule is triggeed, before condition.'),
  condition: miniMALcmd.description('MiniMAL command to check if rule should execute (state to flipped, run actions etc).'),
  actions: miniMALBlock.description('MiniMAL command block to execute when condition is true (& not in flipped state).'),
  resetCondition: miniMALcmd.description('MiniMAL command to check if rule should reset, if it is in flipped state.'),
  resetActions: miniMALBlock.description('MiniMAL command block to execute when resetCondition is true.')
});

exports.Rule = Rule;